//+----------------------------------------------------------------------------+
//|                                                   i-TotalStopCurrency.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  21.12.2011  Indicator of the Total Stop in the Deposit Currency.          |
//|                   .                 |
//|  04.05.2012       Futures.                   |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 0

//-------    ----------------------------------------+
extern string symbol   = "GOLD";
extern color  ecText   = Navy;    //  
extern int    eiCorner = 2;       //   :
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
                                  //   0 -  
//   1 -  
//   2 -  
//   3 -  

//-------    ------------------------------------+

//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void init() 
  {
   Comment("");
  }
//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
void deinit() 
  {
   Comment("");
   for(int i=0; i<4; i++) ObjectDelete("iTotalStopCurrency"+i);
  }
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
void start() 
  {
   double s=ProfitIFStopInCurrency(symbol);

   SetLabel("iTotalStopCurrency0"," ",ecText,5,17,eiCorner);
   SetLabel("iTotalStopCurrency1",DoubleToStr(s,2)+" "+AccountCurrency(),ecText,5,5,eiCorner);
   SetLabel("iTotalStopCurrency2",DoubleToStr(s/AccountBalance()*100,2)+" %",ecText,100,5,eiCorner);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 03.05.2012                                                     |
//|   :   /        |
//|                  .                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ( ""  -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    ( -1  -  )                  |
//|    mn - MagicNumber                ( -1  -  )                    |
//+----------------------------------------------------------------------------+
double ProfitIFStopInCurrency(string sy="",int op=-1,int mn=-1) 
  {
   if(sy=="0") sy=Symbol();  //  
   int    i, k=OrdersTotal(); //   
   int    m;                  //   : 0 - Forex, 1 - CFD, 2 - Futures
   double l;                  //      
   double p;                  //     
   double t;                  //        
   double v;                  //        
   double s=0;                //     

   for(i=0; i<k; i++) 
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) 
        {
         if((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) 
           {
            if((OrderType()==OP_BUY || OrderType()==OP_SELL) && (op<0 || OrderType()==op)) 
              {
               l=MarketInfo(OrderSymbol(), MODE_LOTSIZE);
               m=MarketInfo(OrderSymbol(), MODE_PROFITCALCMODE);
               p=MarketInfo(OrderSymbol(), MODE_POINT);
               t=MarketInfo(OrderSymbol(), MODE_TICKSIZE);
               v=MarketInfo(OrderSymbol(), MODE_TICKVALUE);
               if(OrderType()==OP_BUY) 
                 {
                  if(m==0) s-=(OrderOpenPrice()-OrderStopLoss())/p*v*OrderLots();
                  if(m==1) s-=(OrderOpenPrice()-OrderStopLoss())/p*v/t/l*OrderLots();
                  if(m==2) s-=(OrderOpenPrice()-OrderStopLoss())/p*v*OrderLots();
                  s+=OrderCommission()+OrderSwap();
                 }
               if(OrderType()==OP_SELL) 
                 {
                  if(OrderStopLoss()>0) 
                    {
                     if(m==0) s-=(OrderStopLoss()-OrderOpenPrice())/p*v*OrderLots();
                     if(m==1) s-=(OrderStopLoss()-OrderOpenPrice())/p*v/t/l*OrderLots();
                     if(m==2) s-=(OrderStopLoss()-OrderOpenPrice())/p*v*OrderLots();
                     s+=OrderCommission()+OrderSwap();
                    }
                  else s=-AccountBalance();
                 }
              }
           }
        }
     }
   if(AccountBalance()+s<0) s=-AccountBalance(); //    
   return(s);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   ,  OBJ_LABEL.                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                 |
//|    tx -                                                               |
//|    cl -                                                           |
//|    xd -  X                                              |
//|    yd -  Y                                              |
//|    cr -           (0 -   )                    |
//|                                     1 -                       |
//|                                     2 -                         |
//|                                     3 -   )                    |
//|    fs -                (9 -    )                    |
//+----------------------------------------------------------------------------+
void SetLabel(string nm,string tx,color cl,int xd,int yd,int cr=0,int fs=9) 
  {
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_LABEL,0,0,0);
   ObjectSetText(nm,tx,fs);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_XDISTANCE,xd);
   ObjectSet(nm,OBJPROP_YDISTANCE,yd);
   ObjectSet(nm,OBJPROP_CORNER,cr);
   ObjectSet(nm,OBJPROP_FONTSIZE,fs);
  }
//+----------------------------------------------------------------------------+
